#include "Vektor.h"

#include <iostream>
#include <iomanip> // wegen setw
#include <cassert> // wegen assert
using namespace std;

int Vektor::totalCounter = 0;
int Vektor::totalCounterAssign = 0;


Vektor::Vektor(int dim) {
   ++Vektor::totalCounter;
   dimension = dim;
   daten = new V_BaseType[dim];
}

Vektor::Vektor(const Vektor& v2) {
   ++Vektor::totalCounter;
   dimension = v2.dimension;
   daten = new V_BaseType[dimension];
   for (int i = 0; i<dimension; ++i) {
      daten[i] = v2.daten[i];
   }
}


/** Sofern dimension > 0 ist, wird der Heap-
Speicher von v freigegeben.
*/
Vektor::~Vektor() {
	if (dimension > 0) {
		delete[] daten;
		daten = nullptr;
		dimension = 0;
	}
}



Vektor& Vektor::operator=(const Vektor& v2){
   ++totalCounterAssign;
   if (this != &v2) 	{
      delete[] daten;
      dimension = v2.dimension;
      daten = new V_BaseType[dimension];
      for (int i = 0; i<dimension; ++i) {
         daten[i] = v2.daten[i];
      }
   }
   return *this;
}


Vektor operator+(const Vektor& v1, const Vektor& v2){
	assert(v1.dimension == v2.dimension);
	Vektor erg(v1.dimension);
	for (int i = 0; i < v1.dimension; ++i){
		erg.daten[i] = v1.daten[i] + v2.daten[i];
	}
	return erg;
}

void Vektor::Print() const {
   for (int i=0; i<dimension; ++i){
      cout << setw(4) << daten[i] << ", ";
   }
}


void Vektor::Init(V_BaseType w)  {
	for (int i = 0; i<dimension; ++i){
		daten[i] = w;
	}
}
